package com.uoc.eSalut;

import android.app.DatePickerDialog;
import android.app.Fragment;
import android.app.FragmentManager;
import android.app.Notification;
import android.app.TimePickerDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsManager;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.TimePicker;
import android.widget.Toast;
import com.uoc.eSalut.ParseBD.Pacients;
import com.uoc.eSalut.ParseBD.ParseBd;
import com.uoc.eSalut.ParseBD.Visites;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class AltaVisita extends Fragment implements OnClickListener,View.OnFocusChangeListener,View.OnTouchListener {
	private Context context=null;
    private String cuidador=null;
    private String dniAnt = null;
    private String dniCP =null;
    View rootView=null;
    SimpleDateFormat dateFormatter;
    SimpleDateFormat horaFormatter;
    SimpleDateFormat todoFormatter;
    private String dataOr;
    private String horaOr;
    private String dniOr;
    private EditText hora;
    TimePickerDialog mTimePicker;
    private DatePickerDialog dpd;
    private EditText dataMP;
    private String fechaCalendar;
    private String tituloAnt;

    public AltaVisita(){
    }
     
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
        dateFormatter=new SimpleDateFormat("dd/MM/yyyy", Locale.getDefault());
        todoFormatter=new SimpleDateFormat("dd/MM/yyyy hh:mm", Locale.getDefault());
        horaFormatter=new SimpleDateFormat("hh:mm",Locale.getDefault());
        Intent startingIntent=getActivity().getIntent();
    	rootView = inflater.inflate(R.layout.alta_visita, container,false);
    	context =container.getContext();
        if(startingIntent!=null){
            Bundle b = startingIntent.getBundleExtra("android.intent.extra.INTENT");
            cuidador=startingIntent.getStringExtra("usuari");
            startingIntent.putExtra("titulo", getString(R.string.mn_AltaV));
            if(getArguments()!=null){
                startingIntent.putExtra("dniCP",dniCP);
                startingIntent.putExtra("dni",getArguments().getString("dni"));
                startingIntent.putExtra("data",getArguments().getString("data"));
                startingIntent.putExtra("hora",getArguments().getString("hora"));
                fechaCalendar = getArguments().getString("fechaCalendar");
            }
        }

        EditText dniMP=(EditText) rootView.findViewById(R.id.DniV);
        dataMP=(EditText) rootView.findViewById(R.id.Data);
        dataMP.setOnTouchListener(this);
        dataMP.setOnFocusChangeListener(this);
        hora = (EditText) rootView.findViewById(R.id.Hora);
        hora.setOnTouchListener(this);

        hora.setOnFocusChangeListener(this);
        if(getArguments()!=null) {
            dniCP = getArguments().getString("dniCP");
            dataOr  =getArguments().getString("data");
            dniOr   =getArguments().getString("dni");
            horaOr  =getArguments().getString("hora");
            tituloAnt=getArguments().getString("tituloAnt");
        }


        if(dniCP!=null && !"".equals(dniCP)){
            dniMP.setText(dniCP);
            actualizarDadesPacient(dniCP, cuidador, rootView);
        }

        if(dniOr !=null){
            dniMP.setText(dniOr);
        }
        if(dataMP!=null && dataOr!=null){
            dataMP.setText(dataOr);
        }
        if(hora!=null && horaOr!=null){
            hora.setText(horaOr);
        }
        if(fechaCalendar!=null && !"".equals(fechaCalendar)){
            dataMP.setText(fechaCalendar);
        }
        ImageButton btDni   = (ImageButton)rootView.findViewById(R.id.btDni);
        btDni.setOnClickListener(this);
    	Button btAlta = (Button)rootView.findViewById(R.id.btAltaP);
    	btAlta.setOnClickListener(this);
        EditText data = (EditText) rootView.findViewById(R.id.Data);

        Button btCancelar = (Button)rootView.findViewById(R.id.btCancelarP);
        btCancelar.setOnClickListener(this);
        return rootView;
    }
    public void actualizarDadesPacient(String dni,String cuidador,View v){
        ParseBd bd=new ParseBd(context);
        List<Pacients> pacientses = bd.consultaPacientModif(dni, cuidador);
        dniAnt=dni;
        if(pacientses!=null && pacientses.size()==1){
            TextView nom=(TextView)rootView.findViewById(R.id.NomV);
            TextView cognoms=(TextView)rootView.findViewById(R.id.CognomsV);
            Pacients pacients = pacientses.get(0);
            nom.setText(pacients.getNom());
            cognoms.setText(pacients.getCognoms());
        }else{
            Toast.makeText(context, " Has d'informar un DNI o el que hi ha, no existeix", Toast.LENGTH_LONG).show();

        }


    }
    
    public void onClick(View v){
    	if (v.getId() == R.id.btAltaP){
            EditText dni=(EditText)rootView.findViewById(R.id.DniV);
            TextView nom=(TextView)rootView.findViewById(R.id.NomV);
            TextView cognoms=(TextView)rootView.findViewById(R.id.CognomsV);
            EditText data=(EditText) rootView.findViewById(R.id.Data);
            EditText hour=(EditText) rootView.findViewById(R.id.Hora);
            boolean validacio=true;
            if("".equals(dni.getText().toString())){
                dni.setError("DNI és obligatori d'omplir");
                validacio=false;
                dni.requestFocus();
            }else if(dni.length()!=9){
                dni.setError("DNI ha de tenir una gràndaria de 9");
                validacio=false;
                dni.requestFocus();
            }else if(!validarDni(dni)){
                validacio=false;
                dni.requestFocus();
            }if("".equals(data.getText().toString())){
                data.setError("Data és obligatori d'omplir ");
                if(validacio){
                    validacio=false;
                    data.requestFocus();
                }
            }else if(!validarData(data)){
                data.setError("Format de la data és incorrecte.");
                if (validacio) {
                    validacio=false;
                    data.requestFocus();
                }
            }else if("".equals(hour.getText().toString())) {
                hora.setError("Hora és obligatori d'omplir.");
                if (validacio) {
                    validacio = false;
                    hora.requestFocus();
                }
            }else{
                ParseBd taulaVisites=new ParseBd(context);
                List<Pacients> pacients = taulaVisites.consultaPacient(nom.getText().toString(), dni.getText().toString(), cuidador);
                        if(pacients !=null && pacients.size()>0) {
                            Visites visites = new Visites();
                            visites.setDni(dni.getText().toString());
                            visites.setNom(nom.getText().toString());
                            visites.setCognoms(cognoms.getText().toString());
                            visites.setCuidador(cuidador);
                            try {
                                visites.setFecha(dateFormatter.parse(data.getText().toString()));
                                visites.setHora(horaFormatter.parse(hour.getText().toString()));
                                visites.setData(todoFormatter.parse(data.getText().toString() + " " + hour.getText().toString()));
                            } catch (ParseException e) {
                                e.printStackTrace();
                            }

                            boolean insertat = taulaVisites.afegirVisites(visites);
                            if (insertat) {
                                List<Pacients> pacientsesNot = taulaVisites.consultaPacient(nom.getText().toString(), dni.getText().toString(), cuidador);
                                if (pacientsesNot != null && pacientsesNot.size() > 0) {
                                    Pacients pacientsNot = pacientsesNot.get(0);
                                    Integer telContacte = pacientsNot.getTelCte();
                                    Integer telPaciente = pacientsNot.getTelPac();
                                    SmsManager sms = SmsManager.getDefault();
                                    String telefono = null;
                                    if (telContacte != null) {
                                        telefono = String.valueOf(telContacte);
                                    } else {
                                        telefono = String.valueOf(telPaciente);
                                    }
                                    sms.sendTextMessage(telefono, null, "eS@lut: Visita programada per a la data " + data.getText().toString() + " " + hour.getText().toString(), null, null);
                                }


                                Toast.makeText(context, "Visita Afegida.", Toast.LENGTH_SHORT).show();
                                dni.setText("");
                                nom.setText("");
                                cognoms.setText("");
                                data.setText("");
                                dni.requestFocus();
                                hour.setText("");
                                //crear notificació


                            } else {
                                Toast.makeText(context, "Aquesta visita ja existeix a l'aplicació.\n Si us plau, modifica les dades.", Toast.LENGTH_LONG).show();
                            }
                        }else{
                            Toast.makeText(context, "El pacient no existeix a l'aplicació. Es cancel·la la inserció de visita", Toast.LENGTH_LONG).show();
                        }
                }
    	}

        if(v.getId() == R.id.btDni){
            EditText dni=(EditText)rootView.findViewById(R.id.DniV);
            if("".equals(dni.getText().toString())){
                dni.setError("DNI es obligatori d'omplir");

                dni.requestFocus();
            }else if(dni.length()!=9){
                dni.setError("DNI ha de tenir una gràndaria de 9");
                dni.requestFocus();

            }else if(!validarDni(dni)){
                dni.requestFocus();
            }else{
                dni.setError(null);
                actualizarDadesPacient(dni.getText().toString(), cuidador, rootView);
            }
        }

        if(v.getId()==R.id.btCancelarP){
            if(tituloAnt!=null && !"".equals(tituloAnt)){
                if(getString(R.string.mn_ConsultaP).equals(tituloAnt)){
                    Fragment fragment = new ConsultaPacient();
                    FragmentManager fragmentManager = getFragmentManager();
                    fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
                    getActivity().setTitle(R.string.mn_ConsultaP);
                }else if(getString(R.string.mn_Calendari).equals(tituloAnt)){
                    Fragment fragment = new CalendariPersonalizado();
                    FragmentManager fragmentManager = getFragmentManager();
                    fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
                    getActivity().setTitle(R.string.mn_Calendari);
                }
            }else {
                Fragment fragment = new EntradaCuidador();
                FragmentManager fragmentManager = getFragmentManager();
                fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
                getActivity().setTitle(R.string.title_activity_cuidador_activiy);
            }
        }

    }

    private boolean validarDni(EditText dni){
        //si es NIE, eliminar la x,y,z inicial para tratarlo como nif
        String nif =dni.getText().toString();
        if (nif.toUpperCase().startsWith("X")||nif.toUpperCase().startsWith("Y")||nif.toUpperCase().startsWith("Z"))
            nif = nif.substring(1);

        Pattern nifPattern = Pattern.compile("(\\d{1,8})([TRWAGMYFPDXBNJZSQVHLCKEtrwagmyfpdxbnjzsqvhlcke])");
        Matcher m = nifPattern.matcher(nif);
        if(m.matches()){
            String letra = m.group(2);
            //Extraer letra del NIF
            String letras = "TRWAGMYFPDXBNJZSQVHLCKE";
            int dni2 = Integer.parseInt(m.group(1));
            dni2 = dni2 % 23;
            String reference = letras.substring(dni2,dni2+1);

            if (reference.equalsIgnoreCase(letra)){
                return true;
            }else{
                dni.setError("La lletra del DNI no és correcte");
                return false;
            }
        }
        else {
            dni.setError("El format del DNI no és correcte. Els vuits primers dígits són números i l'últim és una lletra");
            return false;
        }
    }

    private boolean validarData(EditText data){
        boolean validarData=true;
        try {
            Date fecha=dateFormatter.parse(data.getText().toString());
        } catch (ParseException e) {
            validarData=false;
        }
        return validarData;
    }


    private Notification getDefaultNotification(Notification.Builder builder,String data) {
        builder
                .setSmallIcon(R.mipmap.cuidador_50)
                .setTicker("Optional ticker")
                .setWhen(System.currentTimeMillis())
                .setContentTitle("Alta visita")
                .setContentText("Alta visita amb data "+data)
                .setContentInfo("Info");
        //return builder.build(); //A partir de Jelly Bean se usa éste método-
        return builder.getNotification();
    }

    @Override
    public void onStop() {
        super.onStop();
        EditText dni = (EditText) rootView.findViewById(R.id.DniV);
        EditText data = (EditText) rootView.findViewById(R.id.Data);
        EditText hora = (EditText) rootView.findViewById(R.id.Hora);
        Intent intentRe = getActivity().getIntent();
        intentRe.putExtra("dniCP", dniAnt);
        intentRe.putExtra("dni", dni.getText().toString());
        intentRe.putExtra("data", data.getText().toString());
    }

    private void onCreateHoraPicker(){
        final Calendar c = Calendar.getInstance();
        if(!"".equals(hora.getText().toString())){
            try {
                Date fecha=horaFormatter.parse(hora.getText().toString());
                c.setTime(fecha);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
        int hour = c.get(Calendar.HOUR_OF_DAY);
        int minute = c.get(Calendar.MINUTE);

        if(mTimePicker==null || !mTimePicker.isShowing()) {

            // Create a new instance of TimePickerDialog and return it
            mTimePicker = new TimePickerDialog(getActivity(),R.style.timePickerDialog_Theme,new TimePickerDialog.OnTimeSetListener() {
                @Override
                public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
                    String minutos = String.valueOf(minute);
                    if (minute >= 0 && minute < 10) {
                        minutos = "0" + minutos;
                    }
                    hora.setText(hourOfDay + ":" + minutos);
                }
            }, hour, minute, true);
            mTimePicker.setTitle("Tria l'hora");
            mTimePicker.show();

        }

    }


    private void onCreateDatePicker(){
        final Calendar calendar = Calendar.getInstance();
        if(!"".equals(dataMP.getText().toString())){
            try {
                Date fecha=dateFormatter.parse(dataMP.getText().toString());
                calendar.setTime(fecha);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }

        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH);
        int day = calendar.get(Calendar.DAY_OF_MONTH);

            /*
                Initialize a new DatePickerDialog

                DatePickerDialog(Context context, DatePickerDialog.OnDateSetListener callBack,
                    int year, int monthOfYear, int dayOfMonth)
             */
        if(dpd==null || !dpd.isShowing()) {
            dpd = new DatePickerDialog(getActivity(),R.style.datePickerDialog_Theme,new DatePickerDialog.OnDateSetListener() {
                @Override
                public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
                    String day = String.valueOf(dayOfMonth);
                    if(dayOfMonth>=1&&dayOfMonth<=10){
                        day="0"+day;
                    }

                    String month = String.valueOf(monthOfYear+1);
                    if(monthOfYear>=0&&monthOfYear<=8){
                        month="0"+month;
                    }
                    dataMP.setText(day+"/"+month+"/"+year);
                }
            }, year, month, day);
            dpd.setTitle("Tria el dia");
            dpd.setButton(DialogInterface.BUTTON_NEGATIVE, "Cancel·lar", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    dialog.cancel();
                }
            });
            dpd.show();

        }
    }






    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if(v.getId()==R.id.Hora&& hasFocus) {
            onCreateHoraPicker();
        }else if(v.getId()==R.id.Data && hasFocus){
            onCreateDatePicker();
        }
    }

    @Override
    public boolean onTouch(View v, MotionEvent event) {
        if(v.getId()==R.id.Data){
            if(dpd==null || !dpd.isShowing()){
                onCreateDatePicker();
            }
        }else if(v.getId()==R.id.Hora){
            if(mTimePicker==null || !mTimePicker.isShowing()){
                onCreateHoraPicker();
            }
        }
        return false;
    }
}
