package com.uoc.eSalut;

import android.app.Fragment;
import android.app.FragmentManager;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;
import com.parse.ParseException;
import com.parse.ParseQuery;
import com.uoc.eSalut.ParseBD.AdaptadorPacient;
import com.uoc.eSalut.ParseBD.ParseBd;
import com.uoc.eSalut.ParseBD.Visites;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

public class ConsultaVisitaPacient extends AppCompatActivity {
	private String cuidador = null;
	public String posicion = "";
	ListView lista = null;
	ArrayAdapter<String> adaptador;
	final ArrayList<LlistaVisita> lVisites = new ArrayList<LlistaVisita>();
	private String fechaCalendar;
	private String dni;

	public ConsultaVisitaPacient() {
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.consulta_visita_pacient);
		Intent startingIntent = getIntent();
		if (startingIntent != null) {
			cuidador = startingIntent.getStringExtra("usuari");
			fechaCalendar=startingIntent.getStringExtra("fechaCalendar");
			dni=startingIntent.getStringExtra("dniP");
		}
		lista = (ListView) findViewById(R.id.consultaVisita);
		omplirLista(null);
		ImageButton btCancelar =(ImageButton)findViewById(R.id.btEnrere);
		btCancelar.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				startActivity(new Intent(getApplicationContext(),CalendariPacient.class));
			}
		});
	}




	private void omplirLista(final String newText) {

		try {
			List<Visites> listaV=null;
			lVisites.clear();
			Visites visita = new Visites();
			ParseQuery<Visites> query = visita.getQuery();
			query.fromLocalDatastore();
			if (cuidador != null && !"".equals(cuidador)) {
					query.whereEqualTo("cuidador", cuidador);
			}
			if(dni!=null && !"".equals(dni)) {
				query.whereEqualTo("dni",dni);
			}
			if(fechaCalendar!=null && !"".equals(fechaCalendar)){
				SimpleDateFormat fechaFormat=new SimpleDateFormat("dd/MM/yyyy");
				query.whereEqualTo("fecha",fechaFormat.parse(fechaCalendar));
			}
			query.orderByAscending("data");
			int contador = query.count();
			listaV= query.find();
			if(listaV !=null) {
				Iterator<Visites> it = listaV.iterator();
				int x = 0;
				while (it.hasNext()) {
					Visites visitaObject = it.next();
					lVisites.add(new LlistaVisita(visitaObject.getDni(), visitaObject.getNom(), visitaObject.getCognoms(),visitaObject.getData(),visitaObject.getHora(),visitaObject.getFecha()));
					x++;
				}
			}
			lista.setAdapter(new AdaptadorPacient(this, R.layout.fila_visita_pacient, lVisites) {
				@Override
				public void onEntrada(final Object entrada, View view) {
					if (entrada != null) {
						final TextView dni = (TextView) view.findViewById(R.id.listDni);
						dni.setText(((LlistaVisita) entrada).getDNI());
						final TextView nom = (TextView) view.findViewById(R.id.listNom);
						nom.setText(((LlistaVisita) entrada).getNom()+" "+((LlistaVisita) entrada).getCognoms());
						final TextView nomVisita = (TextView) view.findViewById(R.id.listNomVisita);
						nomVisita.setText(((LlistaVisita) entrada).getNom());
						final TextView data = (TextView) view.findViewById(R.id.listData);
						final SimpleDateFormat dateFormatter=new SimpleDateFormat("dd-MM-yyyy HH:mm", Locale.getDefault());
						Date fecha=((LlistaVisita) entrada).getData();
						data.setText(dateFormatter.format(fecha));
					}
				}

			});
		} catch (ParseException e1) {
			e1.printStackTrace();
		} catch (java.text.ParseException e) {
			e.printStackTrace();
		}
	}
}