package com.uoc.eSalut;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.SpannableString;
import android.text.style.UnderlineSpan;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.uoc.eSalut.ParseBD.Cuidadors;
import com.uoc.eSalut.ParseBD.ParseBd;

public class CuidadorLogin extends AppCompatActivity implements View.OnClickListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cuidador_login);
        //boton entrada
        Button entrada = (Button)findViewById(R.id.btAltaP);
        entrada.setOnClickListener(this);
        Button entradaC = (Button)findViewById(R.id.btCancelarP);
        entradaC.setOnClickListener(this);
        //textview clicable
        TextView lblAlta=(TextView)findViewById(R.id.lblAlta);
        SpannableString content = new SpannableString(lblAlta.getText());
        content.setSpan(new UnderlineSpan(), 0, content.length(), 0);
        lblAlta.setText(content);
        lblAlta.setOnClickListener(this);
        TextView lblModif=(TextView)findViewById(R.id.lblModif);
        SpannableString contentModif= new SpannableString(lblModif.getText());
        contentModif.setSpan(new UnderlineSpan(), 0, contentModif.length(), 0);
        lblModif.setText(contentModif);
        lblModif.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if(v.getId()==R.id.btAltaP){
            EditText usuari=(EditText)findViewById(R.id.usuari);
            EditText password=(EditText)findViewById(R.id.password);
            boolean validacio= validarCampsObligatoris(usuari,password);
            if (validacio){
                Cuidadors cuidadors =new Cuidadors();
                cuidadors.setUsuari(usuari.getText().toString());
                cuidadors.setPassword(password.getText().toString());
                ParseBd bd= new ParseBd(getApplicationContext());
                //saber si és a la base de dades local.
                if(bd.esCuidador(cuidadors)){
                    Intent intent = new Intent(this, CuidadorActivity.class);
                    intent.putExtra("usuari",cuidadors.getUsuari());
                    startActivity(intent);
                }else{
                    Toast.makeText(getApplicationContext(),"Usuari i password no trobat a l'aplicació",Toast.LENGTH_LONG).show();
                }
            }

        }else if(v.getId()==R.id.lblAlta){
            startActivity(new Intent(this,CuidadorAlta.class));
        }else if(v.getId()==R.id.lblModif) {
            startActivity(new Intent(this, CuidadorModifP.class));
        }else if(v.getId()==R.id.btCancelarP){
            startActivity(new Intent(getApplicationContext(),MainActivity.class));
        }
    }

    private boolean validarCampsObligatoris(EditText usuari,EditText password){
        boolean validacio=true;

        if("".equals(usuari.getText().toString())){
            usuari.setError("Usuari és obligatori d'omplir");
                usuari.requestFocus();
            validacio=false;
        }else if(usuari.length()<7){
            usuari.setError("Usuari ha de ser,com a mínim, de 7 caracters");
             usuari.requestFocus();
        }else{
            usuari.setError(null);
        }
        if("".equals(password.getText().toString())){
            password.setError("Password és obligatori d'omplir");
            if(validacio) {
                password.requestFocus();
            }
            validacio=false;
        }else if(password.length()<8){
            password.setError("Password ha de ser, com a mínim, de 8 caracters");

            if(validacio) {
                password.requestFocus();
            }
            validacio=false;
        }else{
            password.setError(null);
        }
        return validacio;
    }
    @Override
    public void onBackPressed() {
        startActivity(new Intent(this,MainActivity.class));
    }
}
