package com.uoc.eSalut;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.uoc.eSalut.ParseBD.Cuidadors;
import com.uoc.eSalut.ParseBD.ParseBd;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class CuidadorModifP extends AppCompatActivity implements View.OnClickListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cuidador_modif_password);
        Button btModif = (Button)findViewById(R.id.btModif);
        btModif.setOnClickListener(this);
        Button btCancelar = (Button)findViewById(R.id.btCancelarP);
        btCancelar.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.btModif){
            EditText dni = (EditText)findViewById(R.id.dniC);
            EditText usuari = (EditText) findViewById(R.id.usuari);
            EditText password=(EditText) findViewById(R.id.password);
            EditText rePassword=(EditText)findViewById(R.id.Rpassword);
            boolean validacio = validarCampsObligatoris(dni,usuari, password,rePassword);
            if(validacio){
                Cuidadors cuidadors=new Cuidadors();
                cuidadors.setDni(dni.getText().toString());
                cuidadors.setUsuari(usuari.getText().toString());
                cuidadors.setPassword(password.getText().toString());
                ParseBd taulaCuidador=new ParseBd(getApplicationContext());
                boolean insertat = taulaCuidador.modifPassword(cuidadors);
                if(insertat){
                    Toast.makeText(getApplicationContext(), "Cuidador ha modificat el password.", Toast.LENGTH_SHORT).show();
                    startActivity(new Intent(this,CuidadorLogin.class));
                }else{
                    Toast.makeText(getApplicationContext(),"Aquest cuidador no existeix a l'aplicació.\n Si us plau, has d'estar donat d'alta per poder canviar el password.",Toast.LENGTH_LONG).show();

                }
            }
        }else if(v.getId()==R.id.btCancelarP){
            startActivity(new Intent(getApplicationContext(),CuidadorLogin.class));
        }
    }
    private boolean validarCampsObligatoris(EditText dni,EditText usuari,EditText password,EditText rePassword){
        boolean validacio=true;
        if("".equals(dni.getText().toString())){
            dni.setError("DNI es obligatori d'omplir");
            validacio=false;
            dni.requestFocus();
        }else if(dni.length()!=9){
            dni.setError("DNI ha de tenir una gràndaria de 9");
            validacio=false;
            dni.requestFocus();

        }else if(!validarDni(dni)){
            validacio=false;
            dni.requestFocus();
        }else{
            dni.setError(null);
        }
        if(usuari.getText().toString() == null || "".equals(usuari.getText().toString())){
            usuari.setError("Usuari és obligatori d'omplir");

            if(validacio) {
                usuari.requestFocus();
            }
            validacio=false;
        }else if(usuari.length()<7){
            usuari.setError("Usuari ha de ser,com a mínim, de 7 caracters");

            if(validacio) {
                usuari.requestFocus();
            }
            validacio=false;
        }else{
            usuari.setError(null);
        }
        if(password.getText().toString()==null || "".equals(password.getText().toString())){
            password.setError("Password és obligatori d'omplir");
            if(validacio) {
                password.requestFocus();
            }
            validacio=false;
        }else if(password.length()<8){
            password.setError("Password ha de ser, com a mínim, de 8 caracters");

            if(validacio) {
                password.requestFocus();
            }
            validacio=false;
        }else{
            password.setError(null);
        }

        if(rePassword.getText().toString()==null || "".equals(rePassword.getText().toString())){
            rePassword.setError("Repetir password és obligatori d'omplir");

            if(validacio) {
                rePassword.requestFocus();
            }
            validacio=false;
        }else if(rePassword.length()<8){
            rePassword.setError("Repetir password ha de ser, com a mínim, de 8 caracters");

            if(validacio) {
                rePassword.requestFocus();
            }
            validacio=false;
        }else if(!rePassword.getText().toString().equals(password.getText().toString())){
            rePassword.setError("Els passwords introduits són diferents");
            if(validacio){
                rePassword.requestFocus();
            }
            validacio=false;
        }else{
            rePassword.setError(null);
        }
        return validacio;
    }
    private boolean validarDni(EditText dni){
        //si es NIE, eliminar la x,y,z inicial para tratarlo como nif
        String nif =dni.getText().toString();
        if (nif.toUpperCase().startsWith("X")||nif.toUpperCase().startsWith("Y")||nif.toUpperCase().startsWith("Z"))
            nif = nif.substring(1);

        Pattern nifPattern = Pattern.compile("(\\d{1,8})([TRWAGMYFPDXBNJZSQVHLCKEtrwagmyfpdxbnjzsqvhlcke])");
        Matcher m = nifPattern.matcher(nif);
        if(m.matches()){
            String letra = m.group(2);
            //Extraer letra del NIF
            String letras = "TRWAGMYFPDXBNJZSQVHLCKE";
            int dni2 = Integer.parseInt(m.group(1));
            dni2 = dni2 % 23;
            String reference = letras.substring(dni2,dni2+1);

            if (reference.equalsIgnoreCase(letra)){
                return true;
            }else{
                dni.setError("La lletra del DNI no és correcte");
                return false;
            }
        }
        else {
            dni.setError("El format del DNI no és correcte. Els vuits primers dígits són números i l'últim és una lletra");
            return false;
        }
    }


    @Override
    public void onBackPressed() {
        startActivity(new Intent(this,CuidadorLogin.class));
    }
}
