package com.uoc.eSalut;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import com.uoc.eSalut.ParseBD.Cuidadors;
import com.uoc.eSalut.ParseBD.Pacients;
import com.uoc.eSalut.ParseBD.ParseBd;
import com.uoc.eSalut.ParseBD.Visites;


public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Button pacient = (Button)findViewById(R.id.btPacient);
        pacient.setOnClickListener(this);
        Button cuidador = (Button)findViewById(R.id.btCuidador);
        cuidador.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if(v.getId()==R.id.btCuidador){

            if(verificaConexion(getApplicationContext())) {
                ParseBd  bd = new ParseBd(getApplicationContext());
                Cuidadors cuidadors = new Cuidadors();
                bd.sincronitzarTaulasC(cuidadors);
                Pacients pacients = new Pacients();
                bd.sincronitzarTaulasP(pacients);
                Visites visites = new Visites();
                bd.sincronitzarTaulasV(visites);
            }
            startActivity(new Intent(this, CuidadorLogin.class));

        }else if(v.getId()==R.id.btPacient){
            if(verificaConexion(getApplicationContext())) {
                ParseBd bd = new ParseBd(getApplicationContext());
                Pacients pacients = new Pacients();
                bd.sincronitzarTaulasP(pacients);
                Visites visites = new Visites();
                bd.sincronitzarTaulasV(visites);
            }
            startActivity(new Intent(this,PacientTelefon.class));
        }
    }

    @Override
    public void onBackPressed() {
    }

    public static boolean verificaConexion(Context ctx) {
        boolean bConectado = false;
        ConnectivityManager connec = (ConnectivityManager) ctx
                .getSystemService(Context.CONNECTIVITY_SERVICE);
        // No sólo wifi, también GPRS
        NetworkInfo[] redes = connec.getAllNetworkInfo();
        for (int i = 0; i < 2; i++) {
            // ¿Tenemos conexión? ponemos a true
            if (redes[i].getState() == NetworkInfo.State.CONNECTED) {
                bConectado = true;
            }
        }
        return bConectado;
    }
}
