package com.uoc.eSalut;

import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import com.google.android.gms.appindexing.Action;
import com.google.android.gms.appindexing.AppIndex;
import com.google.android.gms.common.api.GoogleApiClient;

public class MenuPacient extends AppCompatActivity implements View.OnClickListener {

    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */
    private GoogleApiClient client;
    private Integer telefonPacientPref=null;
    private Intent startingIntent;
    private Integer telefonContacte=null;

    public MenuPacient() {
        startingIntent = null;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_menu_pacient);
        Button trucada = (Button) findViewById(R.id.btTrucada);
        trucada.setOnClickListener(this);
        Button consultaV=(Button) findViewById(R.id.btConsultaVP);
        consultaV.setOnClickListener(this);
        SharedPreferences settings=getSharedPreferences("PREFERENCES",0);
        if(settings!=null){
            telefonPacientPref =settings.getInt("telPacient", 0);
        }
        startingIntent=getIntent();
        if(startingIntent!=null){
            if(startingIntent.getStringExtra("telCteP")!=null) {
                telefonContacte = Integer.parseInt(startingIntent.getStringExtra("telCteP"));
            }
        }


        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client = new GoogleApiClient.Builder(this).addApi(AppIndex.API).build();
    }

    @Override
    public void onClick(View v) {
        try {
            if (v.getId() == R.id.btTrucada) {
                //fer trucada
                if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.CALL_PHONE) != PackageManager.PERMISSION_GRANTED) {
                    // TODO: Consider calling
                    //    ActivityCompat#requestPermissions
                    // here to request the missing permissions, and then overriding
                    //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
                    //                                          int[] grantResults)
                    // to handle the case where the user grants the permission. See the documentation
                    // for ActivityCompat#requestPermissions for more details.
                    Toast.makeText(getApplicationContext(),"No té permisos per fer aquesta trucada", Toast.LENGTH_LONG);
                    return;
                }else{
                    String llamada=null;
                    if(telefonContacte!=null && telefonContacte!=0){
                        llamada="tel:"+String.valueOf(telefonContacte);
                    }else if(telefonPacientPref!=null && telefonPacientPref!=0){
                        llamada="tel:"+String.valueOf(telefonPacientPref);
                    }
                    startActivity(new Intent(Intent.ACTION_CALL, Uri.parse(llamada)));
                }
            }

            if(v.getId()==R.id.btConsultaVP){
                startActivity(new Intent(this,CalendariPacient.class));
            }
        } catch (ActivityNotFoundException activityException) {
            Log.e("dialing-example", "Call failed", activityException);
        }

    }

    @Override
    public void onStart() {
        super.onStart();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client.connect();
        Action viewAction = Action.newAction(
                Action.TYPE_VIEW, // TODO: choose an action type.
                "MenuPacient Page", // TODO: Define a title for the content shown.
                // TODO: If you have web page content that matches this app activity's content,
                // make sure this auto-generated web page URL is correct.
                // Otherwise, set the URL to null.
                Uri.parse("http://host/path"),
                // TODO: Make sure this auto-generated app deep link URI is correct.
                Uri.parse("android-app://com.uoc.eSalut/http/host/path")
        );
        AppIndex.AppIndexApi.start(client, viewAction);
    }

    @Override
    public void onStop() {
        super.onStop();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        Action viewAction = Action.newAction(
                Action.TYPE_VIEW, // TODO: choose an action type.
                "MenuPacient Page", // TODO: Define a title for the content shown.
                // TODO: If you have web page content that matches this app activity's content,
                // make sure this auto-generated web page URL is correct.
                // Otherwise, set the URL to null.
                Uri.parse("http://host/path"),
                // TODO: Make sure this auto-generated app deep link URI is correct.
                Uri.parse("android-app://com.uoc.eSalut/http/host/path")
        );
        AppIndex.AppIndexApi.end(client, viewAction);
        client.disconnect();
    }
    @Override
    public void onBackPressed() {
        startActivity(new Intent(this, MainActivity.class));
    }
}
