package com.uoc.eSalut;

import android.app.Fragment;
import android.app.FragmentManager;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import com.uoc.eSalut.ParseBD.Cuidadors;
import com.uoc.eSalut.ParseBD.ParseBd;
import java.util.List;

public class ModificaCuidador extends Fragment implements OnClickListener {
	private Context context=null;
	private String usuari;
	private View rootView;
	private String dniOr;
	private String passwordOr;
	private String repasswordOr;
	private String nomOr;
	private String cognomsOr;
	private String empresaOr;

	public ModificaCuidador(){
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
							 Bundle savedInstanceState) {
		rootView = inflater.inflate(R.layout.modifica_cuidador, container,false);
		TextView user=(TextView)rootView.findViewById(R.id.usuari);
		EditText password=(EditText)rootView.findViewById(R.id.password);
		EditText rePass=(EditText)rootView.findViewById(R.id.rePassword);
		EditText empresa=(EditText)rootView.findViewById(R.id.empresa);
		EditText cognoms=(EditText)rootView.findViewById(R.id.cognoms);
		EditText nom=(EditText)rootView.findViewById(R.id.nom);

		context =container.getContext();
		Button btModifica = (Button)rootView.findViewById(R.id.btModifP);
		btModifica.setOnClickListener(this);
		Button btCancelar = (Button)rootView.findViewById(R.id.btCancelarP);
		btCancelar.setOnClickListener(this);
		Intent startingIntent = getActivity().getIntent();
		if(startingIntent!=null){
			usuari=startingIntent.getStringExtra("usuari");
			startingIntent.putExtra("titulo", getString(R.string.mn_modificacioC));
		}
		if(usuari!=null && !"".equals(usuari)){
			user.setText(usuari);
			Cuidadors cuidador=new Cuidadors();
			cuidador.setUsuari(usuari);
			ParseBd bd=new ParseBd(context);
			List<Cuidadors> cuidadorses = bd.consultaCuidador(usuari);
			if (cuidadorses!=null && cuidadorses.size()==1){
				Cuidadors cuid = cuidadorses.get(0);
				nom.setText(cuid.getNom());
				password.setText(cuid.getPassword());
				cognoms.setText(cuid.getCognoms());
				empresa.setText(cuid.getEmpresa());
				rePass.setText(cuid.getPassword());
			}
		}

		if(getArguments()!=null) {
			passwordOr   =getArguments().getString("password");
			repasswordOr  =getArguments().getString("repassword");
			nomOr		 =getArguments().getString("nom");
			cognomsOr	 =getArguments().getString("cognoms");
			empresaOr	 =getArguments().getString("empresa");
		}

		if(passwordOr!=null){
			password.setText(passwordOr);
		}

		if(repasswordOr!=null){
			rePass.setText(repasswordOr);
		}

		if(nomOr!=null){
			nom.setText(nomOr);
		}

		if(cognomsOr!=null){
			cognoms.setText(cognomsOr);
		}

		if(empresaOr!=null){
			empresa.setText(empresaOr);
		}

		return rootView;
	}

	public void onClick(View v){
		if (v.getId() == R.id.btModifP){
			final EditText password=(EditText)rootView.findViewById(R.id.password);
			final EditText empresa=(EditText)rootView.findViewById(R.id.empresa);
			final EditText cognoms=(EditText)rootView.findViewById(R.id.cognoms);
			final EditText nom=(EditText)rootView.findViewById(R.id.nom);
			final EditText rePass=(EditText)rootView.findViewById(R.id.rePassword);
			if(validarCampsObligatoris(nom,cognoms,password,rePass)){
				Cuidadors cuidadors=new Cuidadors();
				cuidadors.setPassword(password.getText().toString());
				cuidadors.setUsuari(usuari);
				cuidadors.setNom(nom.getText().toString());
				cuidadors.setCognoms(cognoms.getText().toString());
				cuidadors.setEmpresa(empresa.getText().toString());
				ParseBd bd =new ParseBd(context);
				boolean modificat=bd.modificarCuidadors(cuidadors);
				if (modificat) {
					Toast.makeText(context, "Cuidador Modificat.", Toast.LENGTH_SHORT).show();
				}
			}

		}else if(v.getId()==R.id.btCancelarP){
			Fragment fragment = new EntradaCuidador();
			FragmentManager fragmentManager = getFragmentManager();
			fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
			getActivity().setTitle(R.string.title_activity_cuidador_activiy);
		}

	}

	private boolean validarCampsObligatoris(EditText nom,EditText cognoms,EditText password,EditText rePassword){
		boolean validacio=true;
		if("".equals(password.getText().toString())) {
			password.setError("Password és obligatori d'omplir");
			password.requestFocus();
		}else if(password.length()<8) {
			password.setError("Password ha de ser, com a mínim, de 8 caracters");
			password.requestFocus();
		}else{
			password.setError(null);
		}

		if("".equals(rePassword.getText().toString())){
			rePassword.setError("Repetir password és obligatori d'omplir");
			rePassword.requestFocus();
			validacio=false;
		}else if(rePassword.length()<8){
			rePassword.setError("Repetir password ha de ser, com a mínim, de 8 caracters");
			rePassword.requestFocus();
			validacio=false;
		}else if(!rePassword.getText().toString().equals(password.getText().toString())){
			rePassword.setError("Els passwords introduits són diferents");
			rePassword.requestFocus();
			validacio=false;
		}else{
			rePassword.setError(null);
		}
		if("".equals(nom.getText().toString())){
			nom.setError("Nom és obligatori d'omplir");
			if(validacio){
				nom.requestFocus();
			}
			validacio=false;
		}else{
			nom.setError(null);
		}
		if("".equals(cognoms.getText().toString())){
			cognoms.setError("Cognoms és obligatori d'omplir");
			if(validacio) {
				cognoms.requestFocus();
			}
			validacio=false;
		}else{
			cognoms.setError(null);
		}
		return validacio;
	}
	@Override
	public void onStop() {
		super.onStop();
		final EditText password=(EditText)rootView.findViewById(R.id.password);
		final EditText empresa=(EditText)rootView.findViewById(R.id.empresa);
		final EditText cognoms=(EditText)rootView.findViewById(R.id.cognoms);
		final EditText nom=(EditText)rootView.findViewById(R.id.nom);
		final EditText rePass=(EditText)rootView.findViewById(R.id.rePassword);
		Intent intentRe = getActivity().getIntent();
		intentRe.putExtra("nom", nom.getText().toString());
		intentRe.putExtra("empresa", empresa.getText().toString());
		intentRe.putExtra("cognoms", cognoms.getText().toString());
		intentRe.putExtra("password", password.getText().toString());
		intentRe.putExtra("repassword", rePass.getText().toString());
	}

}
