package com.uoc.eSalut;

import android.app.Fragment;
import android.app.FragmentManager;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Spinner;
import android.widget.Toast;
import com.uoc.eSalut.ParseBD.Pacients;
import com.uoc.eSalut.ParseBD.ParseBd;

import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ModificacioPacient extends Fragment implements OnClickListener {
	private Context context=null;
    private String cuidador=null;
    private String dniAnt = null;
    private Integer telPacAnt=null;
    private Integer telCteAnt=null;
    View rootView=null;
    private String dniCP;
    private String dniOr;
    private String nomOr;
    private String cognomsOr;
    private String adrecaOr;
    private String personaContacteOr;
    private String telefonContacteOr;
    private String telefonPacientOr;
    private String nivellOr;

    public ModificacioPacient(){
    }
     
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
        Intent startingIntent=getActivity().getIntent();

    	rootView = inflater.inflate(R.layout.modificacio_pacient, container, false);
    	context =container.getContext();
        if(startingIntent!=null){
            cuidador=startingIntent.getStringExtra("usuari");
            startingIntent.putExtra("titulo","Modificació pacient");
        }
        EditText dniMP=(EditText) rootView.findViewById(R.id.dni);
        if(getArguments()!=null) {
            dniCP = getArguments().getString("dniCP");
            dniOr   =getArguments().getString("dni");
            nomOr		        =getArguments().getString("nom");
            cognomsOr	        =getArguments().getString("cognoms");
            adrecaOr	        =getArguments().getString("adreca");
            personaContacteOr	=getArguments().getString("personaContacte");
            telefonContacteOr   =getArguments().getString("telefonContacte");
            telefonPacientOr    =getArguments().getString("telefonPacient");
            nivellOr            =getArguments().getString("nivell");
        }
        EditText nom=(EditText)rootView.findViewById(R.id.NomP);
        EditText cognoms=(EditText)rootView.findViewById(R.id.CognomsP);
        EditText dir =(EditText)rootView.findViewById(R.id.Dir);
        EditText telCte=(EditText)rootView.findViewById(R.id.TelCteM);
        EditText telPac=(EditText)rootView.findViewById(R.id.TelPac);
        EditText perCte=(EditText)rootView.findViewById(R.id.PerCte);
        Spinner nivell=(Spinner)rootView.findViewById(R.id.nivell);
        if(dniCP!=null && !"".equals(dniCP)){
            dniMP.setText(dniCP);
            actualizarDadesPacient(dniCP,cuidador);
        }

        if(dniOr!=null){
            dniMP.setText(dniOr);
        }
        if(nomOr!=null){
            nom.setText(nomOr);
        }

        if(cognomsOr!=null){
            cognoms.setText(cognomsOr);
        }

        if(adrecaOr!=null){
            dir.setText(adrecaOr);
        }

        if(personaContacteOr!=null){
            perCte.setText(personaContacteOr);
        }

        if(telefonContacteOr!=null){
            telCte.setText(telefonContacteOr);
        }

        if(telefonPacientOr!=null){
            telPac.setText(telefonPacientOr);
        }

        if(nivellOr!=null ) {
            if ("Intermedi".equals(nivellOr)) {
                nivell.setSelection(1);
            } else {
                nivell.setSelection(0);
            }
        }

        ImageButton btDni   = (ImageButton)rootView.findViewById(R.id.btDni);
        btDni.setOnClickListener(this);
    	Button btModif = (Button)rootView.findViewById(R.id.btModif);
    	btModif.setOnClickListener(this);
        Button btCancelar = (Button)rootView.findViewById(R.id.btCancelarP);
        btCancelar.setOnClickListener(this);

        return rootView;
    }
    public void actualizarDadesPacient(String dni,String cuidador){
      ParseBd bd=new ParseBd(context);
        List<Pacients> pacientses = bd.consultaPacientModif(dni, cuidador);
        dniAnt=dni;
        if(pacientses!=null && pacientses.size()==1){
            EditText nom=(EditText)rootView.findViewById(R.id.NomP);
            EditText cognoms=(EditText)rootView.findViewById(R.id.CognomsP);
            EditText dir =(EditText)rootView.findViewById(R.id.Dir);
            EditText telCte=(EditText)rootView.findViewById(R.id.TelCteM);
            EditText telPac=(EditText)rootView.findViewById(R.id.TelPac);
            EditText perCte=(EditText)rootView.findViewById(R.id.PerCte);
            Spinner nivell=(Spinner)rootView.findViewById(R.id.nivell);
            Pacients pacients = pacientses.get(0);
            nom.setText(pacients.getNom());
            cognoms.setText(pacients.getCognoms());
            dir.setText(pacients.getadreca());
           telCte.setText(String.valueOf(pacients.getTelCte()));
            telPac.setText(String.valueOf(pacients.getTelPac()));
            telCteAnt=Integer.parseInt(telCte.getText().toString());
            telPacAnt=Integer.parseInt(telPac.getText().toString());
            perCte.setText(pacients.getPersonaCte());
            if("Intermedi".equals(pacients.getNivell())){
                nivell.setSelection(1);
            }
        }else{
            Toast.makeText(context," Has d'informar un DNI o el que hi ha, no existeix",Toast.LENGTH_LONG).show();

        }


    }
    
    public void onClick(View v){

    	if (v.getId() == R.id.btModif){
            if (rootView!=null) {
                EditText dniMP = (EditText) rootView.findViewById(R.id.dni);
                EditText nom = (EditText) rootView.findViewById(R.id.NomP);
                EditText cognoms = (EditText) rootView.findViewById(R.id.CognomsP);
                EditText dir = (EditText) rootView.findViewById(R.id.Dir);
                EditText telCte = (EditText) rootView.findViewById(R.id.TelCteM);
                EditText telPac = (EditText) rootView.findViewById(R.id.TelPac);
                EditText perCte = (EditText) rootView.findViewById(R.id.PerCte);
                Spinner nivell = (Spinner) rootView.findViewById(R.id.nivell);
                boolean validacio = validarCampsObligatoris(dniMP, nom, cognoms, dir, perCte, telCte, telPac, nivell);
                if (validacio) {
                    Pacients pacients = new Pacients();
                    pacients.setDni(dniMP.getText().toString());
                    pacients.setNom(nom.getText().toString());
                    pacients.setCognoms(cognoms.getText().toString());
                    pacients.setadreca(dir.getText().toString());
                    pacients.setPersonaCte(perCte.getText().toString());
                    pacients.setTelCte(Integer.parseInt(telCte.getText().toString()));
                    pacients.setTelPac(Integer.parseInt(telPac.getText().toString()));
                    pacients.setNivell(nivell.getSelectedItem().toString());
                    pacients.setCuidador(cuidador);
                    ParseBd taulaPacient = new ParseBd(context);
                    boolean modificat = taulaPacient.modificarPacients(telCteAnt,telPacAnt,pacients);
                    if (modificat) {
                        Toast.makeText(context, "Pacient Modificat.", Toast.LENGTH_SHORT).show();
                        Fragment fragment=new ConsultaPacient();
                        //Validamos si el fragment no es nulo
                        FragmentManager fragmentManager = getFragmentManager();
                        fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
                        getActivity().setTitle("Consulta pacient");
                    } else {
                        Toast.makeText(context, "Aquest pacient no existeix a l'aplicació.", Toast.LENGTH_LONG).show();
                    }
                }
            }
    	}
        if(v.getId() == R.id.btDni){
            EditText dni=(EditText)rootView.findViewById(R.id.dni);
            if("".equals(dni.getText().toString())){
                dni.setError("DNI es obligatori d'omplir");

                dni.requestFocus();
            }else if(dni.length()!=9){
                dni.setError("DNI ha de tenir una gràndaria de 9");
                dni.requestFocus();

            }else if(!validarDni(dni)){
                dni.requestFocus();
            }else{
                dni.setError(null);
                actualizarDadesPacient(dni.getText().toString(),cuidador);
            }
        }else if(v.getId()==R.id.btCancelarP){
            Fragment fragment = new ConsultaPacient();
            FragmentManager fragmentManager = getFragmentManager();
            fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
            getActivity().setTitle(R.string.mn_ConsultaP);
        }
    		
    }


    private boolean validarCampsObligatoris(EditText dni,EditText nom,EditText cognoms,EditText adreca,EditText personaCte,EditText telCte,EditText telPac,Spinner nivell){
        boolean validacio=true;
        if("".equals(dni.getText().toString())){
            dni.setError("DNI es obligatori d'omplir");
            validacio=false;
            dni.requestFocus();
        }else if(dni.length()!=9){
            dni.setError("DNI ha de tenir una gràndaria de 9");
            validacio=false;
            dni.requestFocus();

        }else if(!validarDni(dni)){
            validacio=false;
            dni.requestFocus();
        }else if(!dni.getText().toString().equals(dniAnt)){
            validacio=false;
            dni.setError("No es pot modificar el dni.");
            dni.requestFocus();

        }else{
            dni.setError(null);
        }
        if("".equals(nom.getText().toString())){
            nom.setError("Nom és obligatori d'omplir");
            if(validacio){
                nom.requestFocus();
            }
            validacio=false;
        }else{
            nom.setError(null);
        }
        if("".equals(cognoms.getText().toString())){
            cognoms.setError("Cognoms és obligatori d'omplir");
            if(validacio) {
                cognoms.requestFocus();
            }
            validacio=false;
        }else{
            cognoms.setError(null);
        }
        if("".equals(adreca.getText().toString())){
            adreca.setError("Adreça és obligatori d'omplir");

            if(validacio) {
                adreca.requestFocus();
            }
            validacio=false;
        }else{
            adreca.setError(null);
        }
        if("".equals(personaCte.getText().toString())){
            personaCte.setError("Persona contacte és obligatori d'omplir");
            if(validacio) {
                personaCte.requestFocus();
            }
            validacio=false;
        }else{
            personaCte.setError(null);
        }

        if("".equals(telCte.getText().toString())){
            telCte.setError("Telèfon de contacte és obligatori d'omplir");
            if(validacio){
                telCte.requestFocus();
            }
            validacio=false;
        }else if(telCte.length()!=9){
            telCte.setError("Telèfon de contacte ha tenir una grandària de 9 digits");
            if(validacio){
                telCte.requestFocus();
            }
            validacio=false;
        }else{
            telCte.setError(null);
        }

        if("".equals(telPac.getText().toString())){
            telPac.setError("Telèfon del pacient és obligatori d'omplir");
            if(validacio){
                telPac.requestFocus();
            }
            validacio=false;
        }else if(telPac.length()!=9){
            telPac.setError("Telèfon del pacient ha tenir una grandària de 9 digits");
            if(validacio){
                telPac.requestFocus();
            }
            validacio=false;
        }else{
            telPac.setError(null);
        }

        if(nivell.getSelectedItem().toString()==null || "".equals(nivell.getSelectedItem().toString())){
            Toast.makeText(context,"Nivell és obligatori d'omplir",Toast.LENGTH_LONG).show();
            if(validacio){
                nivell.requestFocus();
            }
            validacio=false;
        }
        return validacio;
    }

    private boolean validarDni(EditText dni){
        //si es NIE, eliminar la x,y,z inicial para tratarlo como nif
        String nif =dni.getText().toString();
        if (nif.toUpperCase().startsWith("X")||nif.toUpperCase().startsWith("Y")||nif.toUpperCase().startsWith("Z"))
            nif = nif.substring(1);

        Pattern nifPattern = Pattern.compile("(\\d{1,8})([TRWAGMYFPDXBNJZSQVHLCKEtrwagmyfpdxbnjzsqvhlcke])");
        Matcher m = nifPattern.matcher(nif);
        if(m.matches()){
            String letra = m.group(2);
            //Extraer letra del NIF
            String letras = "TRWAGMYFPDXBNJZSQVHLCKE";
            int dni2 = Integer.parseInt(m.group(1));
            dni2 = dni2 % 23;
            String reference = letras.substring(dni2,dni2+1);

            if (reference.equalsIgnoreCase(letra)){
                return true;
            }else{
                dni.setError("La lletra del DNI no és correcte");
                return false;
            }
        }
        else {
            dni.setError("El format del DNI no és correcte. Els vuits primers dígits són números i l'últim és una lletra");
            return false;
        }
    }

    @Override
    public void onStop() {
        super.onStop();
        EditText dni=(EditText)rootView.findViewById(R.id.dni);
        EditText nom=(EditText)rootView.findViewById(R.id.NomP);
        EditText cognoms=(EditText)rootView.findViewById(R.id.CognomsP);
        EditText dir =(EditText)rootView.findViewById(R.id.Dir);
        EditText telCte=(EditText)rootView.findViewById(R.id.TelCteM);
        EditText telPac=(EditText)rootView.findViewById(R.id.TelPac);
        EditText perCte=(EditText)rootView.findViewById(R.id.PerCte);
        Spinner nivell=(Spinner)rootView.findViewById(R.id.nivell);
        Intent intentRe = getActivity().getIntent();
        intentRe.putExtra("dniCP", dniCP);
        intentRe.putExtra("dni", dni.getText().toString());
        intentRe.putExtra("nom", nom.getText().toString());
        intentRe.putExtra("cognoms", cognoms.getText().toString());
        intentRe.putExtra("adreca", dir.getText().toString());
        intentRe.putExtra("personaContacte", perCte.getText().toString());
        intentRe.putExtra("telefonContacte", telCte.getText().toString());
        intentRe.putExtra("telefonPacient", telPac.getText().toString());
        intentRe.putExtra("nivell", nivell.getSelectedItem().toString());
    }
   
}
