package com.uoc.eSalut;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.uoc.eSalut.ParseBD.Pacients;
import com.uoc.eSalut.ParseBD.ParseBd;

import java.util.List;

public class PacientTelefon extends AppCompatActivity  implements View.OnClickListener{

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pacient_telefon);
        Button entrada=(Button)findViewById(R.id.btEntrada);
        entrada.setOnClickListener(this);
        Button btCancelar=(Button)findViewById(R.id.btCancelarP);
        btCancelar.setOnClickListener(this);
        SharedPreferences settings=getSharedPreferences("PREFERENCES",0);
        Integer telefonPacientPref;
        String nivellPref;
        if(settings!=null){
            telefonPacientPref =settings.getInt("telPacient",0);
            nivellPref=settings.getString("nivellP","");
            if(telefonPacientPref!=0 && !"".equals(nivellPref)){
                enviarMenuActivityPacient(telefonPacientPref,nivellPref);
            }
        }
    }

    @Override
    public void onClick(View v) {
        if(v.getId()==R.id.btEntrada){
            EditText telefon = (EditText)findViewById(R.id.telPacient);
            boolean isValid = validarTelefon(telefon);
            if(isValid){
               enviarMenuActivityPacient(Integer.parseInt(telefon.getText().toString()),null);
            }
            //si ha anat bé es fa la consulta a la bd.
        }else if(v.getId()==R.id.btCancelarP){
            startActivity(new Intent(getApplicationContext(),MainActivity.class));
        }
    }

    private boolean validarTelefon(EditText telefon){
        boolean isValid=true;
      if(!"".equals(telefon.getText().toString())){
            if(telefon.length()!=9){
                telefon.setError("La grandària del telèfon ha de ser de 9 dígits");
                isValid=false;
            }else{
                telefon.setError(null);
            }
        }else if("".equals(telefon.getText().toString())){
            telefon.setError("S'ha d'informar el telèfon per poder entrar a la app");
            isValid=false;
        }
        return isValid;
    }

    @Override
    public void onBackPressed() {
        startActivity(new Intent(this,MainActivity.class));
    }

    public void enviarMenuActivityPacient(Integer telefonPacient,String nivellPref){
        EditText telefon=(EditText)findViewById(R.id.telPacient);
        ParseBd bd=new ParseBd(getApplicationContext());
        List<Pacients> pacientses = bd.consultaPacient(telefonPacient);
        if(pacientses!=null && pacientses.size()>0){
            telefon.setError(null);
            Pacients pacient = pacientses.get(0);
            if(nivellPref==null ||"".equals(nivellPref)) {
                SharedPreferences settings = getSharedPreferences("PREFERENCES", 0);
                SharedPreferences.Editor edit = settings.edit();
                edit.putInt("telPacient", telefonPacient);
                edit.putString("nivellP", pacient.getNivell());
                edit.commit();
            }
            //passar variables a l'activitat del pacient
            Intent intent;
            if(nivellPref!=null && !"".equals(nivellPref)) {
                if("Intermedi".equals(nivellPref)) {
                    intent = new Intent(this, MenuPacient.class);
                }else{
                    intent = new Intent(this, MenuPacientB.class);
                }
            }else{
                if (pacient.getNivell().equals("Intermedi")) {
                    intent = new Intent(this, MenuPacient.class);
                } else {
                    intent = new Intent(this, MenuPacientB.class);
                }
            }
            intent.putExtra("nomP", pacient.getNom());
            intent.putExtra("telCteP",String.valueOf(pacient.getTelCte()));
            intent.putExtra("cognomsP",pacient.getCognoms());
            intent.putExtra("adrecaP",pacient.getadreca());
            intent.putExtra("cuidadorP",pacient.getCuidador());
            intent.putExtra("nomCteP",pacient.getPersonaCte());
            intent.putExtra("dniP",pacient.getDni());
            startActivity(intent);
        }else{
            telefon.setError("El telèfon no existeix a la base de dades.");
        }
    }
}
